import java.io.FileInputStream;
import java.util.List;
import java.util.Map;

import java_cup.runtime.*;


public class Main
{
  public static void main (String[] args) 
    throws Exception
  {
    SymbolFactory sf = new ComplexSymbolFactory ();
    ArithmeticLexer lexer;
    if (args.length == 0) {
      lexer = new ArithmeticLexer (System.in, sf);
    } else {
      lexer = new ArithmeticLexer (new java.io.FileInputStream (args[0]), sf);
    }
    ArithmeticParser parser = new ArithmeticParser (lexer, sf);

    Symbol symbol = parser.parse ();

    List<Decl> decls = (List<Decl>) symbol.value;
    for (Decl decl : decls) {
      System.out.println (decl);
    }

    System.out.println ();

    Interpreter interpreter = new Interpreter ();
    Map<String, Integer> bindings = interpreter.evaluateDecls (decls);
    for (String var : bindings.keySet ()) {
      System.out.println (var + " = " + bindings.get (var));
    }
  }
}

