package clogs.ast;

import clogs.util.Optional;


public class ExpArrayAccess extends Exp
{
  public final Exp array;
  public final Exp index;


  public ExpArrayAccess (Exp array, Exp index)
  {
    this (new Optional<Type> (), array, index);
  }


  ExpArrayAccess (Optional<Type> to, Exp array, Exp index)
  {
    super (to);
    clogs.util.NonNull.check (array, index);
    this.array = array;
    this.index = index;
  }


  public Exp setType (Type type)
  {
    return new ExpArrayAccess (new Optional<Type> (type), array, index);
  }
}
