package clogs.ast;

import clogs.util.Optional;


public class ExpBinOp extends Exp
{
  public enum BinOp { 
    PLUS ("+"),
    MINUS ("-"),
    TIMES ("*"),
    DIVIDE ("/"),
    MOD ("%"),
    LESSTHAN ("<"),
    GREATERTHAN (">"),
    LEQ ("<="),
    GEQ (">="),
    EQUALSEQUALS ("=="),
    BANGEQUALS ("!="),
    AMP ("&"),
    CARET ("^"),
    BAR ("|"),
    AMPAMP ("&&"),
    BARBAR ("||");

    final String string;

    BinOp (String string) 
    {
      this.string = string;
    }

    public String toString ()
    {
      return string;
    }
  };


  public final BinOp op;
  public final Exp left;
  public final Exp right;


  public ExpBinOp (BinOp op, Exp left, Exp right)
  {
    this (new Optional<Type> (), op, left, right);
  }

  
  ExpBinOp (Optional<Type> to, BinOp op, Exp left, Exp right)
  {
    super (to);
    clogs.util.NonNull.check (op, left, right);
    this.op = op;
    this.left = left;
    this.right = right;
  }


  public Exp setType (Type type)
  {
    return new ExpBinOp (new Optional<Type> (type), op, left, right);
  }
}
