package clogs.ast;

import clogs.util.Optional;


public class ExpComma extends Exp
{
  public final Exp left;
  public final Exp right;


  public ExpComma (Exp left, Exp right)
  {
    this (new Optional<Type> (), left, right);
  }


  ExpComma (Optional<Type> to, Exp left, Exp right)
  {
    super (to);
    clogs.util.NonNull.check (left, right);
    this.left = left;
    this.right = right;
  }


  public Exp setType (Type type)
  {
    return new ExpComma (new Optional<Type> (type), left, right);
  }
}
