package clogs.ast;

import clogs.util.List;
import clogs.util.Optional;


public class ExpFunCall extends Exp
{
  public final String name;
  public final List<Exp> args;


  public ExpFunCall (String name, List<Exp> args)
  {
    this (new Optional<Type> (), name, args);
  }


  ExpFunCall (Optional<Type> to, String name, List<Exp> args)
  {
    super (to);
    clogs.util.NonNull.check (name, args);
    this.name = name;
    this.args = args;
  }


  public Exp setType (Type type)
  {
    return new ExpFunCall (new Optional<Type> (type), name, args);
  }
}
