package clogs.ast;

import clogs.util.Optional;


public class ExpUnOp extends Exp
{
  public enum UnOp { 
    MINUS ("-"), 
    BANG ("!");

    final String string;

    UnOp (String string) 
    {
      this.string = string;
    }

    public String toString ()
    {
      return string;
    }
  };

  public final UnOp op;
  public final Exp exp;


  public ExpUnOp (UnOp op, Exp exp)
  {
    this (new Optional<Type> (), op, exp);
  }


  ExpUnOp (Optional<Type> to, UnOp op, Exp exp)
  {
    super (to);
    clogs.util.NonNull.check (op, exp);
    this.op = op;
    this.exp = exp;
  }


  public Exp setType (Type type)
  {
    return new ExpUnOp (new Optional<Type> (type), op, exp);
  }
}
