package clogs.ast;

import clogs.util.List;


public abstract class Stat
{
  public final List<String> labels;


  Stat (List<String> labels)
  {
    clogs.util.NonNull.check (labels);
    this.labels = labels;
  }


  public abstract Stat removeLabels ();

  public abstract Stat addLabel (String label);


  public Stat addLabels (List<String> labels)
  {
    Stat result = this;
    for (String label : labels.reverse ()) {
      result = result.addLabel (label);
    }
    return result;
  }


  public String toString ()
  {
    PrettyPrinter pp = new PrettyPrinter ();
    pp.printStat (this);
    return pp.toString ();
  }
}
