package clogs.ast;

import clogs.util.List;
import clogs.util.Optional;


public class StatCompound extends Stat
{
  public final List<Decl> decls;
  public final List<Stat> stats;


  public StatCompound (List<Decl> decls, List<Stat> stats)
  {
    this (List.<String>nil (), decls, stats);
  }


  StatCompound (List<String> labels, List<Decl> decls, List<Stat> stats)
  {
    super (labels);
    clogs.util.NonNull.check (decls, stats);
    this.decls = decls;
    this.stats = stats;
  }


  public Stat removeLabels ()
  {
    return new StatCompound (List.<String> nil (), decls, stats);
  }


  public Stat addLabel (String label)
  {
    return new StatCompound (labels.cons (label), decls, stats);
  }
}
