package clogs.ast;

import clogs.util.List;


public class StatExp extends Stat
{
  public final Exp exp;


  public StatExp (Exp exp)
  {
    this (List.<String>nil (), exp);
  }


  StatExp (List<String> labels, Exp exp)
  {
    super (labels);
    clogs.util.NonNull.check (exp);
    this.exp = exp;
  }


  public Stat removeLabels ()
  {
    return new StatExp (List.<String> nil (), exp);
  }


  public Stat addLabel (String label)
  {
    return new StatExp (labels.cons (label), exp);
  }
}
