package clogs.ast;

import clogs.util.List;


public class StatGoto extends Stat
{
  public final String target;


  public StatGoto (String target)
  {
    this (List.<String>nil (), target);
  }


  StatGoto (List<String> labels, String target)
  {
    super (labels);
    clogs.util.NonNull.check (target);
    this.target = target;
  }


  public Stat removeLabels ()
  {
    return new StatGoto (List.<String> nil (), target);
  }


  public Stat addLabel (String label)
  {
    return new StatGoto (labels.cons (label), target);
  }
}
