package clogs.ast;

import clogs.util.List;


public class StatIf extends Stat
{
  public final Exp exp;
  public final Stat statT;
  public final Stat statF;


  public StatIf (Exp exp, Stat statT, Stat statF)
  {
    this (List.<String>nil (), exp, statT, statF);
  }


  StatIf (List<String> labels, Exp exp, Stat statT, Stat statF)
  {
    super (labels);
    clogs.util.NonNull.check (exp, statT, statF);
    this.exp = exp;
    this.statT = statT;
    this.statF = statF;
  }


  public Stat removeLabels ()
  {
    return new StatIf (List.<String> nil (), exp, statT, statF);
  }


  public Stat addLabel (String label)
  {
    return new StatIf (labels.cons (label), exp, statT, statF);
  }
}
