package clogs.ast;

import clogs.util.List;
import clogs.util.Optional;


public class StatReturn extends Stat
{
  public final Optional<Exp> oe;


  public StatReturn (Optional<Exp> oe)
  {
    this (List.<String>nil (), oe);
  }


  StatReturn (List<String> labels, Optional<Exp> oe)
  {
    super (labels);
    clogs.util.NonNull.check (oe);
    this.oe = oe;
  }


  public Stat removeLabels ()
  {
    return new StatReturn (List.<String> nil (), oe);
  }


  public Stat addLabel (String label)
  {
    return new StatReturn (labels.cons (label), oe);
  }
}
