package clogs.ast;

import clogs.util.List;


public class StatWhile extends Stat
{
  public final Exp exp;
  public final Stat stat;


  public StatWhile (Exp exp, Stat stat)
  {
    this (List.<String>nil (), exp, stat);
  }


  StatWhile (List<String> labels, Exp exp, Stat stat)
  {
    super (labels);
    clogs.util.NonNull.check (exp, stat);
    this.exp = exp;
    this.stat = stat;
  }


  public Stat removeLabels ()
  {
    return new StatWhile (List.<String> nil (), exp, stat);
  }


  public Stat addLabel (String label)
  {
    return new StatWhile (labels.cons (label), exp, stat);
  }
}
