package clogs.staticanalysis;

import clogs.ast.*;
import clogs.util.List;
import clogs.util.Optional;


public class GatherLabelsInStat
{
  public List<String> labelsDefined = List.nil ();
  public List<String> labelsUsed = List.nil ();

  public void gather (Stat stat)
  {
    labelsDefined = labelsDefined.concat (stat.labels);

    if (stat instanceof StatCompound) {
      StatCompound statC = (StatCompound) stat;
      for (Stat s : statC.stats) {
        gather (s);
      }

    } else if (stat instanceof StatExp) {
      // No labels used.

    } else if (stat instanceof StatGoto) {
      StatGoto statG = (StatGoto) stat;
      labelsUsed = labelsUsed.snoc (statG.target);

    } else if (stat instanceof StatIf) {
      StatIf statI = (StatIf) stat;
      gather (statI.statT);
      gather (statI.statF);

    } else if (stat instanceof StatReturn) {
      // No labels used.

    } else if (stat instanceof StatSkip) {
      // No labels used.

    } else if (stat instanceof StatWhile) {
      StatWhile statW = (StatWhile) stat;
      gather (statW.stat);

    } else {
      throw new RuntimeException ("Missing Stat case: " + stat.getClass ().getName ());
    }
  }
}


