package clogs.util;


class ListCons<A> extends List<A>
{
  final A head;
  final List<A> tail;


  ListCons (A head, List<A> tail)
  {
    NonNull.check (head, tail);
    this.head = head;
    this.tail = tail;
  }


  public boolean isNil ()
  {
    return false;
  }


  public int size ()
  {
    return 1 + tail.size ();
  }


  public A head () 
    throws EmptyListException
  {
    return head;
  }


  public List<A> tail () 
    throws EmptyListException
  {
    return tail;
  }


  public List<A> concat (List<A> l)
  {
    return tail.concat (l).cons (head);
  }


  public List<A> reverse ()
  {
    return reverseAux (List.<A>nil ());
  }


  public List<A> reverseAux (List<A> end)
  {
    return tail.reverseAux (end.cons (head));
  }


  @SuppressWarnings("unchecked")
  public boolean equals (Object o)
  {
    if (o instanceof ListCons) {
      ListCons<A> lCons = (ListCons) o;
      return head.equals (lCons.head) && tail.equals (lCons.tail);
    } else {
      return false;
    }
  }
}
