package clogs.util;

import java.util.NoSuchElementException;


class MapList<A,B> extends Map<A,B>
{
  private final List<A> keys;
  private final List<B> values;


  MapList ()
  {
    this.keys = List.<A>nil ();
    this.values = List.<B>nil ();
  }


  private MapList (List<A> keys, List<B> values)
  {
    this.keys = keys;
    this.values = values;
  }


  public Map<A,B> add (A key, B value)
  {
    return new MapList<A,B> (keys.cons (key), values.cons (value));
  }


  public B get (A key)
  {
    List<A> ks = keys; 
    List<B> vs = values;
    while (!ks.isNil ()) {
      if (ks.head ().equals (key)) {
        return vs.head ();
      }
      ks = ks.tail ();
      vs = vs.tail ();
    }
    return null;
  }


  public List<A> keyList ()
  {
    return keys;
  }


  public String toString ()
  {
    StringBuffer sb = new StringBuffer ();

    if (keys.isNil ()) {
      return ("[]");
    }

    sb.append ("[ ");
    List<A> ks = keys; 
    List<B> vs = values;
    boolean first = true;
    while (!ks.isNil ()) {
      if (first) {
        first = false;
      } else {
        sb.append (", ");
      }
      sb.append (ks.head ());
      sb.append (" = "); 
      sb.append (vs.head ());
      ks = ks.tail ();
      vs = vs.tail ();
    }
    sb.append (" ]");

    return sb.toString ();
  }
}
