package clogs.util;

import java.util.NoSuchElementException;


public class Optional<A> 
{
  private final A contents;


  public Optional ()
  {
    this.contents = null;
  }


  public Optional (A contents)
  {
    NonNull.check (contents);
    this.contents = contents;
  }


  public boolean isEmpty ()
  {
    return (contents == null);
  }


  public A get ()
  {
    if (isEmpty ()) {
      throw new NoSuchElementException ();
    } else {
      return contents;
    }
  }


  public String toString ()
  {
    if (isEmpty ()) {
      return "Optional()";
    } else {
      return "Optional(" + contents + ")";
    }
  }
}


