import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;


class Test2
{
  public static void main (String[] args)
  {
    double failureProbability = Double.parseDouble (args[0]);
    int numLines = 0;

    try {
      FileWriter fw = new FileWriter ("output.txt");

      try {
        for (; numLines < 30; numLines++) {
          fw.write (generateLine (failureProbability) + "\n");
          try {
            Thread.sleep (50);
          } catch (InterruptedException e) {
            // Ignore InterruptedException.
          }
        }
      } catch (E1 e) {
        System.err.println ("Caught E1 exception from generateLine");
      } catch (IOException e) {
        System.err.println ("Unable to output to file");
      } finally {
        try {
          fw.write ("Number of lines written: " + numLines + "\n");
          fw.close ();
        } catch (IOException e) {
          System.err.println ("Unable to write summary entry and close file");
        }
      }

    } catch (IOException e) {
      System.err.println ("Unable to open file");
      e.printStackTrace ();
    }
  }


  static String generateLine (double failureProbability)
    throws E1
  {
    // Model failure with probability failureProbability.
    if (Math.random () < failureProbability) {
      throw new E1 ();
    }

    return "Log entry [" + System.currentTimeMillis () + "ms]";
  }
}
