import util.*;


class Test
{
  public static void main (String[] args)
    throws TypeCheckerException
  {
    Map typeSchemes = createTypeSchemes ();
    Infer infer;
    Map context = Map.empty ();
    Exp e;

    //   fun f i => 
    //     fun g xs => 
    //       if (is_zero (i)) then
    //         []
    //       else
    //         cons (head (xs), ((f (i - 1))) (tail (xs)))

    infer = new Infer (typeSchemes);
    e = 
      new ExpFun 
      ("f", 
       "i", 
       new ExpFun 
       ("g",
        "xs", 
        new ExpIfThenElse
        (new ExpApply (new ExpVar ("is_zero"), new ExpVar ("i")),
         new ExpNil (),
         new ExpCons
         (new ExpApply (new ExpVar ("head"), new ExpVar ("xs")),
          new ExpApply 
          (new ExpApply 
           (new ExpVar ("f"),
            new ExpApply (new ExpApply (new ExpVar ("add"), new ExpVar ("i")), new ExpInt (-1))),
           new ExpApply (new ExpVar ("tail"), new ExpVar ("xs"))))))); 
    System.out.println (e);
    Type t = infer.inferType (context, e);
    System.out.println ("Inferred type is: " + t);
    System.out.println ("Constraints: ");
    System.out.println (infer.constraints);
  }

  
  static Map createTypeSchemes ()
  {
    Map typeSchemes = Map.empty ();

    typeSchemes = 
      typeSchemes.add 
      ("head", 
       new TypeScheme 
       (List.singleton ("a"), 
        new TypeFun (new TypeList (new TypeVar ("a")), new TypeVar ("a"))));

    typeSchemes = 
      typeSchemes.add 
      ("tail", 
       new TypeScheme 
       (List.singleton ("a"), 
        new TypeFun (new TypeList (new TypeVar ("a")), new TypeList (new TypeVar ("a")))));

    typeSchemes = 
      typeSchemes.add 
      ("add", 
       new TypeScheme 
       (List.nil (), 
        new TypeFun (new TypeBase ("int"), new TypeFun (new TypeBase ("int"), new TypeBase ("int")))));

    typeSchemes = 
      typeSchemes.add 
      ("is_zero", 
       new TypeScheme 
       (List.nil (), 
        new TypeFun (new TypeBase ("int"), new TypeBase ("boolean"))));

    typeSchemes = 
      typeSchemes.add 
      ("length", 
       new TypeScheme 
       (List.singleton ("a"), 
        new TypeFun (new TypeList (new TypeVar ("a")), new TypeBase ("int"))));

    return typeSchemes;
  }
}
