package util;


class ListCons extends List
{
  final Object head;
  final List tail;


  ListCons (Object head, List tail)
  {
    if (head == null || tail == null) {
      throw new NullPointerException ();
    }
    this.head = head;
    this.tail = tail;
  }


  public boolean isNil ()
  {
    return false;
  }


  public int size ()
  {
    return 1 + tail.size ();
  }


  public Object head () 
    throws EmptyListException
  {
    return head;
  }


  public List tail () 
    throws EmptyListException
  {
    return tail;
  }


  public List concat (List l)
  {
    return tail.concat (l).cons (head);
  }


  public List reverse ()
  {
    return reverseAux (List.nil ());
  }


  public List reverseAux (List end)
  {
    return tail.reverseAux (end.cons (head));
  }


  public boolean equals (Object o)
  {
    if (o instanceof ListCons) {
      ListCons lCons = (ListCons) o;
      return head.equals (lCons.head) && tail.equals (lCons.tail);
    } else {
      return false;
    }
  }
}
