package util;

import java.util.NoSuchElementException;


public class MapList extends Map
{
  private final List keys;
  private final List values;


  MapList ()
  {
    this.keys = List.nil ();
    this.values = List.nil ();
  }


  private MapList (List keys, List values)
  {
    this.keys = keys;
    this.values = values;
  }


  public Map add (Object key, Object value)
  {
    return new MapList (keys.cons (key), values.cons (value));
  }


  public Object get (Object key)
  {
    List ks = keys; 
    List vs = values;
    while (!ks.isNil ()) {
      if (ks.head ().equals (key)) {
	return vs.head ();
      }
      ks = ks.tail ();
      vs = vs.tail ();
    }
    return null;
  }


  public String toString ()
  {
    StringBuffer sb = new StringBuffer ();

    if (keys.isNil ()) {
      return ("[]");
    }

    sb.append ("[ ");
    List ks = keys; 
    List vs = values;
    boolean first = true;
    while (!ks.isNil ()) {
      if (first) {
	first = false;
      } else {
	sb.append (", ");
      }
      sb.append (ks.head ());
      sb.append (" = "); 
      sb.append (vs.head ());
      ks = ks.tail ();
      vs = vs.tail ();
    }
    sb.append (" ]");

    return sb.toString ();
  }
}
